MODULE KillThemAll3;
  <* + M2EXTENSIONS *>
  <* + M2ADDTYPES *>
  <* WOFF + *>

(** XDS environment 2.51, version 2.50 **)

FROM IO IMPORT WrStr, WrChar, WrCard, WrLn, WrBool, RdLn, RdKey, RdCard, RdChar, KeyPressed;
FROM Lib IMPORT Delay, RANDOM;
FROM Graph IMPORT Init, Rectangle,RawOutText,_clrBLUE, Plot, _clrGREEN, _clrLIGHTYELLOW, _clrWHITE, _clrBLACK, _clrLIGHTBLUE,
_clrBRIGHTWHITE, _clrLIGHTGREEN, _clrMAGENTA,_clrLIGHTMAGENTA, _clrCYAN,_clrRED,_clrBROWN, _clrGRAY, _clrLIGHTCYAN, _clrLIGHTRED;
FROM StandardBitmap IMPORT  DIGIT_SIZE, BitmapEn, DrawBitmap, DrawNumber, DrawDigit, DrawBitmapFile, DrawSavedBitmap;
FROM StandardLib IMPORT RandomCard, RdArrowKey, gPseudoRandom, StartChrono, StopChrono,StrCompare;
FROM StandardSound IMPORT SoundEventEn, InitSound, PlaySoundEvent;
IMPORT FIO;

CONST

 Scr_Width = 910;
 Scr_Height = 700;
 Scr_Width_Spel = 1110;
 Height_Wezen = 20;
 Width_Wezen = 30;
 Height_Kaas = 25;
 Width_Kaas = 25;
 Width_Olifant = 150;
 SIZE = 500;
 SIZE_1 = 10;


TYPE


 Soort = (Menu, OptiesMenu, OptiesSpel);
 Wezen = 	RECORD
 			Bitmap : CARDINAL;
			Levend : CARDINAL;   (*Bij elke staat hoort een bepaald nummer, die bepaalt of de muis levend, geraakt,... is*)
			CoordWidth: INTEGER;
 			CoordHeight: INTEGER;
			Bestaat: BOOLEAN;
			xSnelheid: INTEGER;
			ySnelheid: INTEGER;
			Kant :CARDINAL;
			Verdwijn: CARDINAL;
		END;
		

 Kaasje =	RECORD
			Bitmap: CARDINAL;
			xCoord: INTEGER;
			yCoord: INTEGER;
			xSnelheid: INTEGER;
			ySnelheid: INTEGER;
			Staat : CARDINAL;
			Bestaat : BOOLEAN;
			Slurf: CARDINAL;
		END;		
		
 Winners = 	RECORD
      			Naam: ARRAY[0..15] OF CHAR;
      			Punten: INTEGER;
  		END;
		
 WinnersArr = ARRAY [0..9] OF Winners;

	
VAR
	
 width, height: CARDINAL;
 gMaxAantal: CARDINAL;
 Muis_Gedropt : CARDINAL;
 Level: INTEGER;
 Level_Bitmap : CARDINAL;
 GameOver : BOOLEAN;
 KaasTeller :CARDINAL;
 KaasSoort: CARDINAL;
 MaxAantalLevel : CARDINAL;
 Getal: CARDINAL;
 Teller_Pakje: CARDINAL;
 Score: INTEGER;
 Muis_Dood: CARDINAL;
 WindSterkte: INTEGER;
 Moeilijkheidsgraad: INTEGER;
 Snelheid : CARDINAL;
 GeluidAan: BOOLEAN;
 Soortje : Soort;
 Olifant_ZwartBitmap, OlifantBitmap, Slurf_ZwartBitmap,PauzeBitmap, ZwartBitmap, Kaas_ZwartBitmap :CARDINAL;
 Einde : BOOLEAN;
 HoogsteScores: FIO.File;

 Lijst: WinnersArr;
 Naam : ARRAY [0..15] OF CHAR;

 Aantal_Kazen : ARRAY [1..2] OF CARDINAL;

 Pakje : ARRAY[0..SIZE_1] OF Wezen;
 Muis : ARRAY[0..SIZE] OF Wezen;
 Parachute : ARRAY[0..SIZE] OF Wezen;
 Parachute_Pakje: ARRAY [0..SIZE_1] OF Wezen;
 Kaas : ARRAY[0..30] OF Kaasje;

 Olifant : 	RECORD
 			Levens : INTEGER;
			Bitmap : CARDINAL;
			CoordWidth: INTEGER;
			Snelheid: INTEGER;
		END;
		
 Slurf:		RECORD
 			Bitmap: CARDINAL;
			Staat: CARDINAL;
		END;
		




 PROCEDURE MaakNieuweMuis(Nummer: CARDINAL; Welk: CARDINAL; VAR Object_1, Object_2: ARRAY OF Wezen); 		FORWARD;
 PROCEDURE DodeMuisKaas(Nummer: CARDINAL); 		FORWARD;
 PROCEDURE ParachuteGrond(Nummer: CARDINAL);		FORWARD;
 PROCEDURE KiesDodeMuis(Nummer: CARDINAL);		FORWARD;
 PROCEDURE ZwartScherm();				FORWARD;
 PROCEDURE BeweegMuisVerder();				FORWARD;
 PROCEDURE ToonMenu();					FORWARD;
 PROCEDURE ToonIntroBlad();				FORWARD;
 PROCEDURE ToonOptiesMenu();				FORWARD;
 PROCEDURE TekenSlurf();				FORWARD;
 PROCEDURE TekenOlifant();				FORWARD;
 PROCEDURE BeweegOlifant(y: CARDINAL);			FORWARD;
 PROCEDURE LinkToepassing(a:CARDINAL);			FORWARD;
 PROCEDURE Geluid();					FORWARD;
 PROCEDURE HighScores();				FORWARD;
 PROCEDURE Instructies();				FORWARD;
 PROCEDURE StartSpel();					FORWARD;
 PROCEDURE Pauze();					FORWARD;
 PROCEDURE BeweegPijltjesVertMenu(GrootsteCijfer, Rechthoek_x0, Rechthoek_y0, z: CARDINAL; VAR a: CARDINAL);	FORWARD;
 PROCEDURE MoeilijkheidsGraad(y: CARDINAL);				FORWARD;
 PROCEDURE Wind();       FORWARD;
 PROCEDURE TekenKaders(GrootsteCijfer: CARDINAL; Rechthoek_x0, Rechthoek_y0: CARDINAL; Achtergrond: CARDINAL);				FORWARD;
 PROCEDURE ToonOptiesSpel();				FORWARD;
 PROCEDURE ShowHighScores();				FORWARD;	
 PROCEDURE ToonHighscores();				FORWARD;


 PROCEDURE GegevensLaden(LevelBestand: FIO.File);      (*LISBETH*) (* Inlezen van het juiste levelbestand*)

 VAR
     str : ARRAY [1..20] OF CHAR;


 BEGIN

 gMaxAantal :=  FIO.RdCard(LevelBestand);
 FIO.RdStr(LevelBestand, str);
 MaxAantalLevel := FIO.RdCard(LevelBestand);
 FIO.RdStr(LevelBestand, str);
 Snelheid := FIO.RdCard(LevelBestand);
 FIO.Close(LevelBestand);


 END GegevensLaden;


 PROCEDURE LaadLevel();    (* LISBETH*) (* Bepaalt welk bestand ingelezen moet worden naargelang het level en de moeilijkheidsgraad*)

 VAR
    LevelBestand : FIO.File;

 BEGIN


 IF Moeilijkheidsgraad = 1 THEN
    CASE Level OF
       1:	LevelBestand := FIO.OpenRead("Levels/Level1_1.txt");
                GegevensLaden(LevelBestand);                                    |
       2:	LevelBestand := FIO.OpenRead("Levels/Level2_1.txt");
                GegevensLaden(LevelBestand);                                    |
       3:	LevelBestand := FIO.OpenRead("Levels/Level3_1.txt");
                GegevensLaden(LevelBestand);                                    |
       4:	LevelBestand := FIO.OpenRead("Levels/Level4_1.txt");
                GegevensLaden(LevelBestand);                                    |
       5:	LevelBestand := FIO.OpenRead("Levels/Level5_1.txt");
                GegevensLaden(LevelBestand);                                    |
       6:	LevelBestand := FIO.OpenRead("Levels/Level6_1.txt");
                GegevensLaden(LevelBestand);                                    |
       7:	LevelBestand := FIO.OpenRead("Levels/Level7_1.txt");
                GegevensLaden(LevelBestand);                                    |
       8:	LevelBestand := FIO.OpenRead("Levels/Level8_1.txt");
                GegevensLaden(LevelBestand);                                    |
       9:	LevelBestand := FIO.OpenRead("Levels/Level9_1.txt");
                GegevensLaden(LevelBestand);                                    |
       10:	LevelBestand := FIO.OpenRead("Levels/Level10_1.txt");
                GegevensLaden(LevelBestand);
    END;
 ELSIF Moeilijkheidsgraad = 2 THEN
    CASE Level OF
       1:	LevelBestand := FIO.OpenRead("Levels/Level1_2.txt");
                GegevensLaden(LevelBestand);                                    |
       2:	LevelBestand := FIO.OpenRead("Levels/Level2_2.txt");
                GegevensLaden(LevelBestand);                                    |
       3:	LevelBestand := FIO.OpenRead("Levels/Level3_2.txt");
                GegevensLaden(LevelBestand);                                    |
       4:	LevelBestand := FIO.OpenRead("Levels/Level4_2.txt");
                GegevensLaden(LevelBestand);                                    |
       5:	LevelBestand := FIO.OpenRead("Levels/Level5_2.txt");
                GegevensLaden(LevelBestand);                                    |
       6:	LevelBestand := FIO.OpenRead("Levels/Level6_2.txt");
                GegevensLaden(LevelBestand);                                    |
       7:	LevelBestand := FIO.OpenRead("Levels/Level7_2.txt");
                GegevensLaden(LevelBestand);                                    |
       8:	LevelBestand := FIO.OpenRead("Levels/Level8_2.txt");
                GegevensLaden(LevelBestand);                                    |
       9:	LevelBestand := FIO.OpenRead("Levels/Level9_2.txt");
                GegevensLaden(LevelBestand);                                    |
       10:	LevelBestand := FIO.OpenRead("Levels/Level10_2.txt");
                GegevensLaden(LevelBestand);
    END;
 ELSIF Moeilijkheidsgraad = 3 THEN
    CASE Level OF
       1:	LevelBestand := FIO.OpenRead("Levels/Level1_3.txt");
                GegevensLaden(LevelBestand);                                    |
       2:	LevelBestand := FIO.OpenRead("Levels/Level2_3.txt");
                GegevensLaden(LevelBestand);                                    |
       3:	LevelBestand := FIO.OpenRead("Levels/Level3_3.txt");
                GegevensLaden(LevelBestand);                                    |
       4:	LevelBestand := FIO.OpenRead("Levels/Level4_3.txt");
                GegevensLaden(LevelBestand);                                    |
       5:	LevelBestand := FIO.OpenRead("Levels/Level5_3.txt");
                GegevensLaden(LevelBestand);                                    |
       6:	LevelBestand := FIO.OpenRead("Levels/Level6_3.txt");
                GegevensLaden(LevelBestand);                                    |
       7:	LevelBestand := FIO.OpenRead("Levels/Level7_3.txt");
                GegevensLaden(LevelBestand);                                    |
       8:	LevelBestand := FIO.OpenRead("Levels/Level8_3.txt");
                GegevensLaden(LevelBestand);                                    |
       9:	LevelBestand := FIO.OpenRead("Levels/Level9_3.txt");
                GegevensLaden(LevelBestand);                                    |
       10:	LevelBestand := FIO.OpenRead("Levels/Level10_3.txt");
                GegevensLaden(LevelBestand);
    END;
 END;

 END LaadLevel;


 PROCEDURE TekenSlurf();   (***LISBETH***)    (***Tekenen van juiste slurf***)

 BEGIN

 CASE Slurf.Staat OF

    1: Slurf.Bitmap := DrawBitmapFile(Olifant.CoordWidth + 40, 535,"Afbeeldingen/slurf_1.bmp", width, height);  |

    2: Slurf.Bitmap := DrawBitmapFile(Olifant.CoordWidth + 40, 535,"Afbeeldingen/slurf_2.bmp", width, height);  |

    3: Slurf.Bitmap := DrawBitmapFile(Olifant.CoordWidth + 40, 535,"Afbeeldingen/slurf_3.bmp", width, height);  |

    4: Slurf.Bitmap := DrawBitmapFile(Olifant.CoordWidth + 40, 535,"Afbeeldingen/slurf_4.bmp", width, height);  |

    5: Slurf.Bitmap := DrawBitmapFile(Olifant.CoordWidth + 40, 535,"Afbeeldingen/slurf_5.bmp", width, height);  |

 END;

 END TekenSlurf;


 PROCEDURE TekenOlifant();   (**LISBETH**) (**Tekenen van Olifant en overgaan naar TekenSlurf procedure**)

 BEGIN

 DrawSavedBitmap(Olifant.CoordWidth, 600, OlifantBitmap);
 TekenSlurf();

 END TekenOlifant;


 PROCEDURE ClearRecords(Max: CARDINAL; VAR Object: ARRAY OF Wezen);     (*LISBETH*) (* Leegmaken van alle Wezenarrays *)

 VAR
 Nummer: CARDINAL;

 BEGIN

 FOR Nummer := 0 TO Max DO
    WITH Object[Nummer] DO
       Levend := 0;
       Bestaat:= FALSE;
    END;
 END;

 END ClearRecords;


 PROCEDURE ClearKaas(Nummer: CARDINAL);      (*LISBETH*)  (* Leegmaken van Kaasarray *)

 BEGIN

 WITH Kaas[Nummer] DO
    Staat := 0;
    Bestaat:= FALSE;
 END;

 END ClearKaas;


 (*** Procedures voor het maken van wezens ***)


 PROCEDURE MuisToegelaten(Nummer: CARDINAL; Object_1: ARRAY OF Wezen): BOOLEAN;    (**LISBETH**)
 (**Nakijken of er zich nog geen wezen op die plaats bevindt**)

 VAR
    Teller : CARDINAL;

 BEGIN

    Teller := 0;
    WHILE Teller < Nummer  DO
       IF Object_1[Nummer].CoordWidth = Object_1[Teller].CoordWidth THEN
          IF Object_1[Teller].CoordHeight < 2 * Height_Wezen THEN
	     RETURN TRUE;
	  END;
       END;
       Teller := Teller +1;
    END;
  RETURN  FALSE;

 END MuisToegelaten;


 PROCEDURE MaakNieuweMuis(Nummer: CARDINAL; Welk: CARDINAL; VAR Object_1, Object_2: ARRAY OF Wezen);    (**LISBETH**) (**Aanmaken van nieuwe muis**)

 VAR
    y : CARDINAL;
    Toegelaten: BOOLEAN;

 BEGIN


 Toegelaten := TRUE;

 WHILE Toegelaten DO                                       (* Zolang er zich een muis op dezelfde plaats bevindt blijft de lus doorgaan*)
    y := RandomCard(1,25);
    Object_1[Nummer].CoordWidth := Width_Wezen*y;
    Object_1[Nummer].CoordHeight := Height_Wezen;
    Toegelaten := MuisToegelaten(Nummer, Object_1);
 END;

 CASE Welk OF	
    1:		Object_1[Nummer].Bitmap:= DrawBitmapFile(Object_1[Nummer].CoordWidth, Object_1[Nummer].CoordHeight, "Afbeeldingen/muis_stndrd.bmp", width, height);
                Getal := Getal + 1;
                Object_1[Nummer].Levend := 1;							                                                           |
    2: 	 	Object_1[Nummer].Bitmap:= DrawBitmapFile(Object_1[Nummer].CoordWidth, Object_1[Nummer].CoordHeight, "Afbeeldingen/pakje_kaas1.bmp", width, height);     |
    3:  	Object_1[Nummer].Bitmap:= DrawBitmapFile(Object_1[Nummer].CoordWidth, Object_1[Nummer].CoordHeight, "Afbeeldingen/pakje_kaas2.bmp", width, height);     |

 ELSE

 END;

 WITH Object_1[Nummer] DO
    Verdwijn := 0;
    Bestaat := TRUE;
    ySnelheid := Snelheid;
 END;

 WITH Object_2[Nummer] DO                                    (*Initialiseren van de parachute*)
    CoordHeight := 0;
    CoordWidth := Width_Wezen*y;
    Bitmap := DrawBitmapFile(Object_2[Nummer].CoordWidth, Object_2[Nummer].CoordHeight, "Afbeeldingen/parachute1.bmp", width, height);
    Verdwijn := 0;
    Bestaat := TRUE;
    Levend := 1;
    ySnelheid := Snelheid;
 END;

 END MaakNieuweMuis;


 PROCEDURE DropMuizenEen();   (**LISBETH**) (* Procedure om muizen te tekenen aan het begin van elk level *)

 VAR
   Nummer: CARDINAL;

 BEGIN

   FOR Nummer := 0 TO gMaxAantal-1 DO
      MaakNieuweMuis(Nummer,1,Muis, Parachute) ;
   END ;
   ZwartBitmap := DrawBitmapFile(100, 100, "Afbeeldingen/zwart.bmp", width, height);
 END DropMuizenEen;


 PROCEDURE BeweegMuis(Nummer: CARDINAL; welk: CARDINAL; VAR Object_1, Object_2: ARRAY OF Wezen);  (**LISBETH**)  (* Muizen snelheid pixels over het scherm laten afdalen *)

 VAR
 tijd : CARDINAL;

 BEGIN

 tijd := 5;
 Delay(tijd);

 DrawSavedBitmap(Object_1[Nummer].CoordWidth, Object_1[Nummer].CoordHeight, ZwartBitmap);
 DrawSavedBitmap(Object_2[Nummer].CoordWidth, Object_2[Nummer].CoordHeight, ZwartBitmap);

 Object_1[Nummer].CoordHeight := Object_1[Nummer].CoordHeight + Object_1[Nummer].ySnelheid;
 Object_1[Nummer].CoordWidth := Object_1[Nummer].CoordWidth + WindSterkte;
 Object_2[Nummer].CoordWidth := Object_2[Nummer].CoordWidth +  WindSterkte;

 IF (Object_1[Nummer].CoordWidth >= Scr_Width-5) OR (Object_1[Nummer].CoordWidth <= 0) THEN
    Object_1[Nummer].CoordWidth := Object_1[Nummer].CoordWidth - 2*WindSterkte;
    Object_2[Nummer].CoordWidth := Object_2[Nummer].CoordWidth - 2*WindSterkte;
 END;


 DrawSavedBitmap(Object_1[Nummer].CoordWidth, Object_1[Nummer].CoordHeight, Object_1[Nummer].Bitmap);


 WITH Object_2[Nummer] DO
    CoordHeight := Object_2[Nummer].CoordHeight + Object_2[Nummer].ySnelheid;
    DrawSavedBitmap(Object_2[Nummer].CoordWidth, Object_2[Nummer].CoordHeight,Object_2[Nummer].Bitmap);
    (*Bitmap:= DrawBitmapFile(Object_2[Nummer].CoordWidth, Object_2[Nummer].CoordHeight, "parachute1.bmp", width2, height2);   *)
 END;


 END BeweegMuis;


 PROCEDURE BeweegOlifant(y: CARDINAL);    (**LISBETH**) (**Slurf en olifant laten bewegen**)

 BEGIN

 IF y = 77 THEN
    IF Olifant.CoordWidth < Scr_Width - Width_Olifant - Olifant.Snelheid THEN
      DrawSavedBitmap(Olifant.CoordWidth, 600, Olifant_ZwartBitmap);
      DrawSavedBitmap(Olifant.CoordWidth + 35 , 525, Slurf_ZwartBitmap);
      Olifant.CoordWidth := Olifant.CoordWidth + Olifant.Snelheid;
      TekenOlifant();
    END;
 ELSIF y = 75 THEN
    IF Olifant.CoordWidth > Olifant.Snelheid THEN
       DrawSavedBitmap(Olifant.CoordWidth, 600, Olifant_ZwartBitmap);
       DrawSavedBitmap(Olifant.CoordWidth + 35 , 525, Slurf_ZwartBitmap);
       Olifant.CoordWidth := Olifant.CoordWidth - Olifant.Snelheid;
       TekenOlifant();
    END;
 ELSIF y = 72 THEN
    IF Slurf.Staat >= 2 THEN
       DrawSavedBitmap(Olifant.CoordWidth + 35 , 525, Slurf_ZwartBitmap);
       Slurf.Staat := Slurf.Staat - 1;
       TekenSlurf();
    END;
 ELSIF y = 80 THEN
    IF Slurf.Staat <= 4 THEN
       DrawSavedBitmap(Olifant.CoordWidth + 35 , 525, Slurf_ZwartBitmap);
       Slurf.Staat := Slurf.Staat +1;
       TekenSlurf();
    END;

 END;

 END BeweegOlifant;

 (**** Kaas procedures ****)

 PROCEDURE TellerAanpassen();    (*LISBETH*)

 BEGIN

 IF KaasTeller < 30 THEN
    KaasTeller := KaasTeller + 1;
 ELSE
    KaasTeller := 0;
 END;

 END TellerAanpassen;


 PROCEDURE SchietKaas(Teller: CARDINAL);   (*LISBETH*)

 BEGIN

 IF Aantal_Kazen[KaasSoort] >= 1 THEN
    IF GeluidAan THEN
       PlaySoundEvent(Schieten);
    END;
    Aantal_Kazen[KaasSoort] := Aantal_Kazen[KaasSoort] - 1;
    Kaas[Teller].Staat := KaasSoort;
    IF KaasSoort = 1 THEN
       DrawNumber(982, 360,  10, 0, 0);
       DrawNumber(982, 360,  100, 0, 0);
       DrawNumber(982, 360,  Aantal_Kazen[1], 17, 0);
    ELSE
       DrawNumber(982, 520,  10, 0, 0);
       DrawNumber(982, 520, Aantal_Kazen[2], 17, 0);
    END;
    Kaas[Teller].Bestaat := TRUE;
    Kaas[Teller].Slurf := Slurf.Staat;

    CASE Slurf.Staat OF                                                    (* De richting naar waar de slurf wijst hoort samen met de richting waarin de kaas geschoten wordt*)

     1: 	WITH Kaas[Teller] DO
       			xCoord := Olifant.CoordWidth+15;
        		yCoord := 555;
                	xSnelheid := -20;
	        	ySnelheid := 0;
		END;					  	   |

     2:  	WITH Kaas[Teller] DO
     			xCoord := Olifant.CoordWidth+15;
     			yCoord := 510;
			xSnelheid := -20;
			ySnelheid := -20;
		END;			 			   |

     3: 	WITH Kaas[Teller] DO
     			xCoord := Olifant.CoordWidth+60;
     			yCoord := 510;
			xSnelheid := 0;
			ySnelheid := -20;
		END;						   |

     4: 	WITH Kaas[Teller] DO
     			xCoord := Olifant.CoordWidth+105;
     			yCoord := 510;
			xSnelheid := 20;
			ySnelheid := -20;
		END;						   |
	
     5:    	WITH Kaas[Teller] DO
     			xCoord := Olifant.CoordWidth+105;
     			yCoord := 555;
			xSnelheid := 20;
			ySnelheid := 0;
		END;

    END;
 END;


 END SchietKaas;


  PROCEDURE TekenKaas(Teller : CARDINAL);  (*LISBETH*) (*Kiezen welke kaas getekend zal worden*)

  BEGIN
  IF Kaas[Teller].Bestaat THEN
  IF Kaas[Teller].Staat  = 1 THEN
     Kaas[Teller].Bitmap := DrawBitmapFile(Kaas[Teller].xCoord, Kaas[Teller].yCoord, "Afbeeldingen/Kaas.bmp", width, height);
  ELSIF Kaas[Teller].Staat = 2 THEN
     Kaas[Teller].Bitmap := DrawBitmapFile(Kaas[Teller].xCoord, Kaas[Teller].yCoord, "Afbeeldingen/Kaas_Speciaal.bmp", width, height);

  END;
   END;
  END TekenKaas;

  PROCEDURE BeweegKaas(Teller : CARDINAL);   (*LISBETH*) (*bewegen van kaas*)

  BEGIN

  IF (Kaas[Teller].xCoord < Scr_Width - Width_Kaas) AND (Kaas[Teller].xCoord > Width_Kaas) THEN
     IF (Kaas[Teller].yCoord < Scr_Height - Height_Kaas) AND (Kaas[Teller].yCoord > Height_Kaas) THEN
	DrawSavedBitmap(Kaas[Teller].xCoord, Kaas[Teller].yCoord, Kaas_ZwartBitmap);
        Kaas[Teller].xCoord := Kaas[Teller].xCoord + Kaas[Teller].xSnelheid;
        Kaas[Teller].yCoord := Kaas[Teller].yCoord + Kaas[Teller].ySnelheid;
 	TekenKaas(Teller);
     ELSE
	DrawSavedBitmap(Kaas[Teller].xCoord, Kaas[Teller].yCoord, Kaas_ZwartBitmap);
	Kaas[Teller].Bestaat := FALSE;
     END;
  ELSE
     DrawSavedBitmap(Kaas[Teller].xCoord, Kaas[Teller].yCoord, Kaas_ZwartBitmap);
     Kaas[Teller].Bestaat := FALSE;
  END;

  END BeweegKaas;

 (***Procedure voor het toevoegen van wind (horizontale snelheid)***)

 PROCEDURE Wind();        (*LISBETH*) (* De windsterkte is een globale variabele die elke beweegVerder iteratie aangepast wordt*)

 VAR
 i: CARDINAL;

 BEGIN

 i := RandomCard(1,7);
 CASE i OF
    1:   WindSterkte := -9;							|
    2:   WindSterkte := -6;							|
    3:   WindSterkte := -3;							|
    4:   WindSterkte := 0;							|
    5:   WindSterkte := 3;							|
    6:   WindSterkte := 6;							|
    7:   WindSterkte := 9;							

 END;

 WindSterkte := WindSterkte *(Moeilijkheidsgraad-1);


 END Wind;

 (****** Procedures voor pakje******)

 PROCEDURE LaatPakjeVallen();                 (*LISBETH*) (*Bepaalt welk soort pakje moet vallen*)

 VAR
 i: CARDINAL;

 BEGIN

 i := RandomCard(1,5);

 CASE i OF

     1,2,3,4: 	Pakje[Teller_Pakje].Levend := 1;					|
     5:       	Pakje[Teller_Pakje].Levend := 2;					|
 ELSE

 END;

 IF Teller_Pakje < 10 THEN
    Teller_Pakje := Teller_Pakje+1;
 ELSE
    Teller_Pakje := 0
 END;

 END LaatPakjeVallen;


  (****Procedure voor het bepalen van de score****)


 PROCEDURE BepaalScore(WelkGeraakt, Nummer: CARDINAL);         (*LISBETH*)

 BEGIN

 IF WelkGeraakt = 1  THEN

    CASE Kaas[Nummer].Slurf OF
       1,5: Score := Score + 75 * Moeilijkheidsgraad;      |
       2,4: Score := Score + 100 * Moeilijkheidsgraad;     |
       3: Score := Score + 50 * Moeilijkheidsgraad; ;
    ELSE

    END;

 ELSIF WelkGeraakt = 3 THEN
       Score := Score + 150 * Moeilijkheidsgraad; ;
 END;

 DrawNumber(982, 114,  Score, 17, 0);

 END BepaalScore;

  (**** Procedures voor toetsengebruik tijdens het spel ****)

  PROCEDURE ToetsenGebruik (x: CARDINAL);   (*LISBETH*) (*Bepalen wat er gebeurt wanneer men op een bepaalde toets gedrukt heeft*)

  VAR

  y : CARDINAL;

  BEGIN


  IF x = 0 THEN
     y := VAL(CARDINAL,RdKey());
     BeweegOlifant(y);

  ELSE
     CASE x OF
        9:  IF KaasSoort = 1 THEN
	       KaasSoort := 2;
	    ELSE
	       KaasSoort := 1;
	    END;                  |
        32: TellerAanpassen();
	    SchietKaas(KaasTeller);
	    TekenKaas(KaasTeller); |
	109,59:           (*Hier worden 2 nummers gezet omdat hij de m niet altijd als 109 inleest (hij durft af en toe te denken dat er met een querty toetsenbord gewerkt wordt), zelfde geldt voor q*)
	     Geluid();            |
        112: Pauze();
	     ZwartScherm();
	     IF Einde THEN
                TekenOlifant();
    	     END;      		  |
	113,97 : ToonOptiesSpel();
                 IF Einde THEN
                    TekenOlifant();
    	         END;      	  |	
     ELSE

     END;
  END;

 END ToetsenGebruik;


 PROCEDURE Check();  (*LISBETH*) (*Nagaan of er op een toets dedrukt wordt*)

 VAR

 x :CARDINAL;
 z : CHAR;

 BEGIN

    IF (KeyPressed()) THEN
       x := VAL(CARDINAL,RdKey());
       WHILE KeyPressed() DO     (*Deze lus zorgt ervoor dat wanneer er op een verschillende toets geduwd wordt, meteen de actie die bij de nieuwe toets*)
          z := RdKey();          (*   hoort ingezet wordt *)
       END;
       ToetsenGebruik(x);
    END;

  END Check;


(************* Procedures voor dode & vallende muizen/parachutes *****************)

 PROCEDURE DodeMuisKaas(Nummer: CARDINAL);  (*LISBETH*) (* De 3 volgende procedures staan in voor het tonen van de juiste bitmap wanneer een muis geraakt wordt *)

 BEGIN
 Muis[Nummer].Bitmap:= DrawBitmapFile(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, "Afbeeldingen/muis_kaas1.bmp", width, height);
 Muis[Nummer].ySnelheid := 3 * Snelheid;
 Muis[Nummer].Levend :=  2;
 Parachute[Nummer].Levend := 2;
 Parachute[Nummer].Verdwijn := 0;

 END DodeMuisKaas;

 PROCEDURE DodeMuisParachute(Nummer:CARDINAL);   (*LISBETH*)

 BEGIN

 Parachute[Nummer].Bitmap := DrawBitmapFile(Parachute[Nummer].CoordWidth, Parachute[Nummer].CoordHeight, "Afbeeldingen/para_geraakt.bmp", width, height);
 Muis[Nummer].Bitmap:= DrawBitmapFile(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, "Afbeeldingen/muis_para_dood.bmp", width, height);
 Muis[Nummer].ySnelheid:= 3*Snelheid;
 Muis[Nummer].Levend := 3;
 Parachute[Nummer].ySnelheid := 3*Snelheid;
 Parachute[Nummer].Levend := 3;

 END DodeMuisParachute;

 PROCEDURE DodeMuisSpecialeKaas(Nummer: CARDINAL);   (*LISBETH*)

 BEGIN

 Muis[Nummer].Bitmap:= DrawBitmapFile(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, "Afbeeldingen/muis_groen.bmp", width, height);
 Muis[Nummer].Levend := 4;
 Muis[Nummer].ySnelheid := 3*Snelheid;
 Parachute[Nummer].Levend := 4;
 Parachute[Nummer].ySnelheid := 3*Snelheid;

 END DodeMuisSpecialeKaas;


 PROCEDURE KiesDodeMuis(Nummer: CARDINAL);   (*LISBETH*) (*Laat dode muis bewegen*)

 BEGIN

 IF Muis[Nummer].CoordHeight <= Scr_Height - Height_Wezen - 25 THEN
    DrawSavedBitmap(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, ZwartBitmap);
    Muis[Nummer].CoordHeight := Muis[Nummer].CoordHeight + Muis[Nummer].ySnelheid;
    DrawSavedBitmap(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, Muis[Nummer].Bitmap);
 ELSE
    IF Muis[Nummer].Verdwijn < 7 THEN
       CASE Muis[Nummer].Levend OF
          2:     Muis[Nummer].Bitmap:= DrawBitmapFile(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, "Afbeeldingen/muis_grond.bmp", width, height);        |
          3,4:   Muis[Nummer].Bitmap:= DrawBitmapFile(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, "Afbeeldingen/muis_para_grond.bmp", width, height);
       END;
       IF Muis[Nummer].Verdwijn = 5 THEN
          Muis[Nummer].Bitmap:= DrawBitmapFile(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, "Afbeeldingen/stofwolk.bmp", width, height);
	  Muis_Dood := Muis_Dood +1;
       ELSIF Muis[Nummer].Verdwijn = 6 THEN
          DrawSavedBitmap(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, ZwartBitmap);
       END;
       Muis[Nummer].Verdwijn:=Muis[Nummer].Verdwijn +1;
    END;
 END;

 END KiesDodeMuis;


 PROCEDURE VerdwijnParachute(Nummer: CARDINAL);  (*LISBETH*) (* Laat de parachute verdwijnen *)

 BEGIN

 IF Parachute[Nummer].Verdwijn < 5  THEN
    Parachute[Nummer].Bitmap := DrawBitmapFile(Parachute[Nummer].CoordWidth, Parachute[Nummer].CoordHeight, "Afbeeldingen/para_grond.bmp", width, height);
 ELSIF Parachute[Nummer].Verdwijn = 5 THEN
    Parachute[Nummer].Bitmap := DrawBitmapFile(Parachute[Nummer].CoordWidth, Parachute[Nummer].CoordHeight, "Afbeeldingen/stofwolk.bmp", width, height);
 ELSIF Parachute[Nummer].Verdwijn = 6 THEN
    DrawSavedBitmap(Parachute[Nummer].CoordWidth, Parachute[Nummer].CoordHeight, ZwartBitmap);
    Parachute[Nummer].Bestaat := FALSE;
 END;

 END VerdwijnParachute;

 PROCEDURE ParachuteGrond(Nummer: CARDINAL);  (* LISBETH *)   (* Laat de parachute voortbewegen *)

 BEGIN

 CASE Parachute[Nummer].Levend OF

    2:  IF Parachute[Nummer].CoordHeight >= Scr_Height - 20 THEN
           VerdwijnParachute(Nummer);
       	   Parachute[Nummer].Verdwijn := Parachute[Nummer].Verdwijn + 1;
        ELSE
           DrawSavedBitmap(Parachute[Nummer].CoordWidth, Parachute[Nummer].CoordHeight, ZwartBitmap);

	   IF ((Parachute[Nummer].CoordWidth + 2*WindSterkte) < Scr_Width ) AND ((Parachute[Nummer].CoordWidth + 2*WindSterkte) >  0) THEN
	      Parachute[Nummer].CoordWidth := Parachute[Nummer].CoordWidth + 2 * WindSterkte;
	   ELSE
	      Parachute[Nummer].CoordWidth := Parachute[Nummer].CoordWidth - 2 * WindSterkte;
	   END;
           Parachute[Nummer].CoordHeight := Parachute[Nummer].CoordHeight + Parachute[Nummer].ySnelheid;
           DrawSavedBitmap(Parachute[Nummer].CoordWidth, Parachute[Nummer].CoordHeight, Parachute[Nummer].Bitmap);
        END; |
    3,4:  IF Parachute[Nummer].CoordHeight < Scr_Height - 10 THEN
             DrawSavedBitmap(Parachute[Nummer].CoordWidth, Parachute[Nummer].CoordHeight, ZwartBitmap);
	     Parachute[Nummer].CoordHeight := Parachute[Nummer].CoordHeight + Parachute[Nummer].ySnelheid;
             DrawSavedBitmap(Parachute[Nummer].CoordWidth, Parachute[Nummer].CoordHeight, Parachute[Nummer].Bitmap);
	  END;
 END;

 END ParachuteGrond;

 PROCEDURE VerdwijnPakje(Teller : CARDINAL);      (*LISBETH*)

 VAR                                          (*Nadat het pakje de grond geraakt heeft, blijft het er nog enige tijd liggen zodat de speler de
 						mogelijkheid heeft erover te rijden en het op die manier op te rapen*)
 BEGIN

 IF Pakje[Teller].Bestaat THEN
    IF Pakje[Teller].Verdwijn < 15 THEN
       Pakje[Teller].Verdwijn := Pakje[Teller].Verdwijn +1;
       IF (Olifant.CoordWidth < Pakje[Teller].CoordWidth+ Width_Wezen) AND (Olifant.CoordWidth > Pakje[Teller].CoordWidth) THEN
          Score := Score + 50 * Moeilijkheidsgraad; ;
          Pakje[Teller].Bestaat := FALSE;
          DrawSavedBitmap(Pakje[Teller].CoordWidth, Pakje[Teller].CoordHeight, ZwartBitmap);
          IF Pakje[Teller].Levend = 1 THEN
             Aantal_Kazen[1] := Aantal_Kazen[1] + 20;
             DrawNumber(982, 360,  Aantal_Kazen[1], 17, 0);
          ELSE
             Aantal_Kazen[2] := Aantal_Kazen[2] + 5;
             DrawNumber(982, 520,  Aantal_Kazen[2], 17, 0);
          END;
       ELSIF (Olifant.CoordWidth + Width_Olifant < Pakje[Teller].CoordWidth+ Width_Wezen) AND (Olifant.CoordWidth +Width_Olifant > Pakje[Teller].CoordWidth) THEN
          Score := Score + 50 * Moeilijkheidsgraad; ;
	  Pakje[Teller].Bestaat := FALSE;
          DrawSavedBitmap(Pakje[Teller].CoordWidth, Pakje[Teller].CoordHeight, ZwartBitmap);
          IF Pakje[Teller].Levend = 1 THEN
             Aantal_Kazen[1] := Aantal_Kazen[1] + 20;
             DrawNumber(982, 360,  Aantal_Kazen[1], 17, 0);
          ELSE
             Aantal_Kazen[2] := Aantal_Kazen[2] + 5;
             DrawNumber(982, 520,  Aantal_Kazen[2], 17, 0);
          END;
       END;
    ELSE
       Pakje[Teller].Bestaat := FALSE;
       DrawSavedBitmap(Pakje[Teller].CoordWidth, Pakje[Teller].CoordHeight, ZwartBitmap);
    END;
 END;


 END VerdwijnPakje;

 (******** Procedure om na te gaan of er een muis geraakt is *******)


 PROCEDURE AndereMuizenGeraakt(a,b: CARDINAL);  (*LISBETH*)  (* Wanneer een muis met een groene kaas geraakt wordt, sterven de muizen binnen een bepaalde straal ook*)

 VAR
 c : CARDINAL;

 BEGIN

 FOR c := 0 TO MaxAantalLevel DO
    IF Muis[c].Levend = 1 THEN
       IF (Muis[c].CoordWidth <= Muis[b].CoordWidth + Width_Wezen + 100) AND (Muis[c].CoordWidth >= Muis[b].CoordWidth -100) THEN
          IF (Muis[c].CoordHeight <= Muis[b].CoordHeight + Height_Wezen + 100) AND (Muis[c].CoordHeight >= Muis[b].CoordHeight -100) THEN
             DodeMuisSpecialeKaas(c);
             MaakNieuweMuis(c+gMaxAantal, 1, Muis, Parachute);
	     BepaalScore(1,a);
	  END;
       END;
    END;
 END;

 END AndereMuizenGeraakt;

 PROCEDURE Nakijken(a,b: CARDINAL; Welke: CARDINAL; VAR Object: ARRAY OF Wezen);    (*LISBETH*) (*Bepalen of er een muis geraakt is*)

 BEGIN

 IF Kaas[a].Staat = 1 THEN
          ClearKaas(a);
	  DrawSavedBitmap(Kaas[a].xCoord, Kaas[a].yCoord, Kaas_ZwartBitmap);
	  CASE Welke OF
             1:		IF GeluidAan THEN
	                   PlaySoundEvent(BijnaDodeMuis);
			END;
	                DodeMuisKaas(b);
		        MaakNieuweMuis(b+gMaxAantal,1, Muis, Parachute);
			BepaalScore(1,a);|
	     2:         DrawSavedBitmap(Object[b].CoordWidth, Object[b].CoordHeight, ZwartBitmap);
   		        DrawSavedBitmap(Parachute_Pakje[b].CoordWidth, Parachute_Pakje[b].CoordHeight, ZwartBitmap);
			Object[b].Bestaat := FALSE;
			Parachute_Pakje[b].Bestaat := FALSE;
   			Parachute_Pakje[b].Levend := 0;
			IF Pakje[b].Levend = 1 THEN
                           Aantal_Kazen[1] := Aantal_Kazen[1]+20;
     		           DrawNumber(982, 360,  Aantal_Kazen[1], 17, 0);
			ELSIF Pakje[b].Levend = 2 THEN
                           Aantal_Kazen[2] := Aantal_Kazen[2]+5;
                           DrawNumber(982, 520,  Aantal_Kazen[2], 17, 0);
			END;
   			Object[b].Levend := 0;
			BepaalScore(3,a);|
	     4: 	IF GeluidAan THEN
	                   PlaySoundEvent(BijnaDodeMuis);
			END;
	     		DodeMuisParachute(b);
	                MaakNieuweMuis(b+gMaxAantal,1, Muis, Parachute);
			BepaalScore(1,a);  			|
	     5:	        IF Pakje[b].Levend = 1 THEN
                           Aantal_Kazen[1] := Aantal_Kazen[1]+20;
                           DrawNumber(982, 360,  Aantal_Kazen[1], 17, 0);
			ELSIF Pakje[b].Levend = 2 THEN
                           Aantal_Kazen[2] := Aantal_Kazen[2]+5;
                           DrawNumber(982, 520,  Aantal_Kazen[2], 17, 0);
			END;
			BepaalScore(3,a);
			DrawSavedBitmap(Pakje[b].CoordWidth, Pakje[b].CoordHeight, ZwartBitmap);
   		        DrawSavedBitmap(Object[b].CoordWidth, Object[b].CoordHeight, ZwartBitmap);
			Pakje[b].Bestaat := FALSE;
			Object[b].Bestaat := FALSE;	
			Object[b].Levend := 0;
					                                                                                                 |
	  END;
	

	
 ELSIF Kaas[a].Staat = 2 THEN              (*Wanneer een muis met een groene kaas geraakt wordt, wordt de vorige procedure opgeroepen*)
    AndereMuizenGeraakt(a,b);
    ClearKaas(a);
    DrawSavedBitmap(Kaas[a].xCoord, Kaas[a].yCoord, Kaas_ZwartBitmap);
 END;

 END Nakijken;



 PROCEDURE MuisGeraakt(Max: CARDINAL; Welke:CARDINAL; VAR Object: ARRAY OF Wezen); (*LISBETH*) (*Bepaalt of de muis geraakt is*)

 VAR
 a,b: CARDINAL;

 BEGIN

 FOR a := 0 TO 30 DO
       FOR b := 0 TO Max DO
          IF Kaas[a].Bestaat THEN
             IF Object[b].Levend = 1 THEN
	
 IF (Kaas[a].xCoord >= Object[b].CoordWidth-5) AND (Kaas[a].xCoord <= Object[b].CoordWidth + Width_Wezen+5) THEN
    IF (Kaas[a].yCoord > Object[b].CoordHeight) AND (Kaas[a].yCoord <= Object[b].CoordHeight + Height_Wezen+5) THEN
       Nakijken(a,b, Welke, Object);
    ELSIF (Kaas[a].yCoord + Height_Kaas >= Object[b].CoordHeight) AND (Kaas[a].yCoord + Height_Kaas <= Object[b].CoordHeight + Height_Wezen+5) THEN
       Nakijken(a,b, Welke, Object);
    END;
 ELSIF (Kaas[a].xCoord + Width_Kaas >= Object[b].CoordWidth-5) AND (Kaas[a].xCoord + Width_Kaas <= Object[b].CoordWidth + Width_Wezen+5) THEN
    IF (Kaas[a].yCoord > Object[b].CoordHeight) AND (Kaas[a].yCoord <= Object[b].CoordHeight + Height_Wezen+5) THEN
       Nakijken(a,b,Welke, Object);
    ELSIF (Kaas[a].yCoord + Height_Kaas > Object[b].CoordHeight) AND (Kaas[a].yCoord + Height_Kaas <= Object[b].CoordHeight + Height_Wezen+5) THEN
      Nakijken(a,b, Welke, Object);
    END;
 END;
          END;
       END;
    END;
 END;
 END MuisGeraakt;


 (** Veranderen van level **)

 PROCEDURE VolgendLevel();     (*LISBETH*)  (*Volgend level oproepen*)

 VAR
 Nummer: CARDINAL;
 x: CHAR;
 BEGIN

 ZwartScherm();
 Score := Score + Level * 1000 * Moeilijkheidsgraad;
 Level := Level + 1;
 IF Level <= 10 THEN
    ClearRecords(SIZE, Muis);
    ClearRecords(SIZE, Parachute);
    ClearRecords(SIZE_1, Pakje);
    ClearRecords(SIZE_1, Parachute_Pakje);
    Muis_Dood := 0;
    Muis_Gedropt := 0;
    Teller_Pakje := 0;
    FOR Nummer := 0 TO 30 DO
       ClearKaas(Nummer);
    END;

    CASE Level OF
       1: 	Level_Bitmap := DrawBitmapFile(0, 0, "Menu/Level_1.bmp", width, height);	|	
       2: 	Level_Bitmap := DrawBitmapFile(0, 0, "Menu/Level_2.bmp", width, height);	|	
       3: 	Level_Bitmap := DrawBitmapFile(0, 0, "Menu/Level_3.bmp", width, height);	|	
       4: 	Level_Bitmap := DrawBitmapFile(0, 0, "Menu/Level_4.bmp", width, height);	|	
       5: 	Level_Bitmap := DrawBitmapFile(0, 0, "Menu/Level_5.bmp", width, height);	|	
       6: 	Level_Bitmap := DrawBitmapFile(0, 0, "Menu/Level_6.bmp", width, height);	|	
       7: 	Level_Bitmap := DrawBitmapFile(0, 0, "Menu/Level_7.bmp", width, height);	|	
       8: 	Level_Bitmap := DrawBitmapFile(0, 0, "Menu/Level_8.bmp", width, height);	|	
       9: 	Level_Bitmap := DrawBitmapFile(0, 0, "Menu/Level_9.bmp", width, height);	|	
      10: 	Level_Bitmap := DrawBitmapFile(0, 0, "Menu/Level_10.bmp", width, height);	
    END;
    x := RdKey();
    Delay(100);
    ZwartScherm();
    DrawNumber(982, 114,  Score, 17, 0);
    Olifant.CoordWidth := 400;
    Olifant.Snelheid := 20;
    Slurf.Staat := 3;
    Kaas_ZwartBitmap :=  DrawBitmapFile(Olifant.CoordWidth, 600,"Afbeeldingen/Kaas_Zwart.bmp", width, height);
    Olifant_ZwartBitmap :=  DrawBitmapFile(Olifant.CoordWidth, 600,"Afbeeldingen/zwart_.bmp", width, height);
    Slurf_ZwartBitmap :=  DrawBitmapFile(Olifant.CoordWidth, 535,"Afbeeldingen/slurf_zwart.bmp", width, height);
    OlifantBitmap := DrawBitmapFile(Olifant.CoordWidth, 600, 'Afbeeldingen/Olifant.bmp', width, height);
    TekenOlifant();
    LaadLevel();
    DropMuizenEen();
    KaasSoort := 1;
 ELSE
    GameOver := FALSE;
    Muis_Dood := MaxAantalLevel + 10;
 END;

 END VolgendLevel;


 (**** Procedure zolang muis levend is*****)


 PROCEDURE MuisEen(Nummer: CARDINAL); (*LISBETH*)    (*Bepaalt of de muis de grond levend bereikt heeft*)

 VAR

 BEGIN

 IF Muis[Nummer].CoordHeight <= Scr_Height - Height_Wezen - 10 THEN
       BeweegMuis(Nummer, 1, Muis, Parachute);
 ELSE
    Muis_Dood := Muis_Dood +1;
    Parachute[Nummer].Bitmap := DrawBitmapFile(Parachute[Nummer].CoordWidth, Parachute[Nummer].CoordHeight, "Afbeeldingen/zwart.bmp", width, height);
       Muis[Nummer].Bitmap := DrawBitmapFile(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, "Afbeeldingen/muis_rechts.bmp", width, height);
       Olifant.Levens := Olifant.Levens - 1;
       DrawNumber(982, 243,  Olifant.Levens, 17, 0);
       IF Olifant.Levens = 0 THEN
          GameOver:=FALSE;
	  Muis_Dood := MaxAantalLevel +10;
	  IF GeluidAan THEN
	     PlaySoundEvent(Gedaan);
	  END;
	  ZwartScherm();
       ELSE
          MaakNieuweMuis(Nummer+gMaxAantal, 1, Muis, Parachute);
       END;
    Muis[Nummer].Levend := 10 ;
 END;

 END MuisEen;


 PROCEDURE MuisBlij (Nummer: CARDINAL); (*LISBETH*)(* Wanneer levende muis grond bereikt begint  zij te dansen*)

 BEGIN

 Muis[Nummer].Bitmap := DrawBitmapFile(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, "Afbeeldingen/zwart.bmp", width, height);

 IF Muis[Nummer].Kant = 1 THEN
    Muis[Nummer].Bitmap := DrawBitmapFile(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, "Afbeeldingen/muis_links.bmp", width, height);
    Muis[Nummer].Kant := 0;
 ELSE
    Muis[Nummer].Bitmap := DrawBitmapFile(Muis[Nummer].CoordWidth, Muis[Nummer].CoordHeight, "Afbeeldingen/muis_rechts.bmp", width, height);
    Muis[Nummer].Kant := 1;
 END;

 END MuisBlij;



 PROCEDURE BeweegMuisVerder(); (* LISBETH *)  (* Belangrijkste procedure: staat in voor het bewegen (doorverwijzen) van alle figuren *)

 VAR
    Nummer: CARDINAL;
    Teller: CARDINAL;
 BEGIN

 WHILE Muis_Dood < MaxAantalLevel DO                       (*Er moeten een bepaald aantal muizen gedood worden per level*)
    IF (GameOver) AND (Einde) THEN
       IF Getal >= 8 THEN                                  (* Om de zoveel gedode muizen wordt er weer munitie aangereikt*)
          LaatPakjeVallen();
          MaakNieuweMuis(Teller_Pakje-1, Pakje[Teller_Pakje - 1].Levend +1, Pakje, Parachute_Pakje);
          Getal := 0;
       END;
       StartChrono();
       WHILE  StopChrono() < 0.2 DO
	  Check();                                          (*Gedurende dit interval wordt nagegaan of er op een toets gedrukt wordt*)
       END;
       FOR Teller := 0 TO 30 DO
	  IF Kaas[Teller].Bestaat THEN
	     BeweegKaas(Teller);
          END;
       END;
       MuisGeraakt(MaxAantalLevel+2*gMaxAantal, 1, Muis);
       MuisGeraakt(MaxAantalLevel+2*gMaxAantal, 4, Parachute);
       MuisGeraakt(SIZE_1, 2, Pakje);
       MuisGeraakt(SIZE_1, 5, Parachute_Pakje);
       Wind();
       FOR Teller := 0 TO SIZE_1 DO                                        (*Bewegen van het pakje (en de bijhorende parachute)*)
          IF Pakje[Teller].Bestaat THEN
	     IF Pakje[Teller].CoordHeight < Scr_Height - Height_Wezen THEN
	        IF Pakje[Teller].Levend = 1 THEN
                   BeweegMuis(Teller, 2, Pakje, Parachute_Pakje);
	        ELSIF Pakje[Teller].Levend = 2 THEN
	           BeweegMuis(Teller,3, Pakje, Parachute_Pakje);
                END;
	     ELSE
	        VerdwijnPakje(Teller);
	     END;
	  END;
       END;

       FOR Nummer := 0 TO 250 DO
	  IF (GameOver) AND (Einde) THEN                (*De GameOver voorwaarde wordt 2 maal aangehaald zodat het spel meteen stopt wanneer men gameOver heeft*)
             IF (Muis[Nummer].Bestaat) THEN
                IF Muis[Nummer].Levend = 1 THEN         (*Bewegen van een levende muis*)
	           MuisEen(Nummer);
                ELSIF (2 <= Muis[Nummer].Levend) AND (Muis[Nummer].Levend <= 4) THEN        (*Geraakt muizen (2 = MuisGeraakt, 3 = ParachuteGeraakt, 4 = SpecialeKaas*)
	           KiesDodeMuis(Nummer);
                   ParachuteGrond(Nummer);
	        ELSIF Muis[Nummer].Levend = 10 THEN                                         (*Laten dansen van de levende muis*)
	           MuisBlij(Nummer);
	        END;
	     END;
	  END;
       END;

    END;
 END;

 END BeweegMuisVerder;


 (*** MENU's ***)


 PROCEDURE ZwartScherm();  (* OLIVIA *) (* Zwart scherm tekenen*)

 BEGIN

 Rectangle( 0, 0, Scr_Width, Scr_Height, _clrBLACK, TRUE);
	
 END ZwartScherm;


 PROCEDURE StartSpel();  (*OLIVIA*) (*Initialiseren van variabelen ed aan het begin van het spel*)

 VAR
 MenuScherm: CARDINAL;
 x: CHAR;

 BEGIN

 ToonMenu();
 ZwartScherm();
 Level := 0;
 GameOver := TRUE;
 Score := 0;
 Olifant.Levens := 5;
 Aantal_Kazen[1] := 30;
 Aantal_Kazen[2] := 0;
 IF NOT Init(0, 0 , Scr_Width_Spel, Scr_Height) THEN
     WrStr("Sorry, graphics doesn't work");WrLn;
 END;

 MenuScherm := DrawBitmapFile(910,0, 'Menu/menu_rechts.bmp', width, height);
 DrawNumber(982, 114,  Score, 17, 0);
 DrawNumber(982, 243,  Olifant.Levens, 17, 0);
 DrawNumber(982, 360,  Aantal_Kazen[1], 17, 0);
 DrawNumber(982, 520,  Aantal_Kazen[2], 17, 0);
 Einde := TRUE;

 WHILE Einde DO
    IF GameOver THEN
       VolgendLevel();
       BeweegMuisVerder();
    ELSE
       Level_Bitmap := DrawBitmapFile(0, 0, "Menu/GameOver.bmp", width, height);
       x := RdKey();
       ZwartScherm();
       HighScores();
       x := RdKey();
       StartSpel();
    END;
 END;

 END StartSpel;

 PROCEDURE SchrijfNaam();     (*LISBETH*) (*Bij het bereiken van de highscores kan de speler zijn naam op het scherm schrijven *)

 CONST

 Breedte = 50;
 yCoord = 510;


 VAR

 Letter, LetterTek : CARDINAL;
 xCoord: INTEGER;
 Teller,i : INTEGER;
 Tekening : CARDINAL;

 BEGIN

 Tekening := DrawBitmapFile(0,0, 'Menu/highscore1.bmp',width,height);
 Teller := -1;
 xCoord := 105;

 WHILE Letter <> 13 DO
    IF (KeyPressed()) THEN
       Letter := VAL(CARDINAL,RdKey());

       IF Teller < 15 THEN
          CASE Letter OF

      		 32:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/Zwarte_Letter.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := ' ';|
       		97:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/A.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'a';|
       		98:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/B.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'b';|
       		99:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/C.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'c';|
      		100:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/D.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'd';|
       		101:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/E.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'e';|
       		102:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/F.bmp',width, height);
        		Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'f';|
       		103:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/G.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'g';|
       		104:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/H.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'h';|
       		105:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/I.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'i';|
       		106:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/J.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'j';|
       		107:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/K.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'k';|
       		108:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/L.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'l';|
       		109:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/M.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'm';|
       		110:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/N.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'n';|
       		111:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/O.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'o';|
       		112:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/P.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'p';|
       		113:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/Q.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'q';|
       		114:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/R.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'r';|
      		115:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/S.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 's';|
       		116:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/T.bmp',width, height);	
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
	        	Naam[Teller] := 't';|
       		117:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/U.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'u';|
       		118:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/V.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'v';|
       		119:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/W.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'w';|
       		120:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/X.bmp',width, height);
        		Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'x';|
       		121:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/Y.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'y';|
       		122:	LetterTek := DrawBitmapFile(xCoord, yCoord, 'Letters/Z.bmp',width, height);
       			Teller := Teller +1;
                	xCoord := xCoord + Breedte;	
       			Naam[Teller] := 'z';|
          ELSE
       END;
       	
    END;
       IF Letter = 8 THEN
          IF Teller >= 0 THEN
             LetterTek := DrawBitmapFile(xCoord-Breedte, yCoord, 'Letters/Zwarte_Letter.bmp',width, height);
	     Naam[Teller]:= ' ';
	     WrLn();
             xCoord := xCoord - Breedte;
	     Teller := Teller - 1;
          END;
       END;

    END;
 END;

FOR i := 0 TO Teller DO
	        WrChar(Naam[i]);
             END;


 END SchrijfNaam;

 PROCEDURE LinkToepassing (a:CARDINAL); (*OLIVIA*)  (*linkt de juiste procedure aan de juiste kader in het hoofdmenu*)

 BEGIN	
    CASE a OF
	2 : ToonOptiesMenu();                                 |
        3 : ShowHighScores();                                     |
	4 : Instructies();
    ELSE;
    END;
	
 END LinkToepassing;


 PROCEDURE TekstMenu(z:CARDINAL);      (*OLIVIA*)  (*schrijft de juiste tekst in de kaders aan het juiste menu*)

 BEGIN

 IF z = 1 THEN
   RawOutText( 390, 140, 17, "Start Spel");
   RawOutText( 390, 290, 17, "Opties");
   RawOutText( 390, 440, 17, "Highscores");
   RawOutText( 390, 590, 17, "Instructies");
 ELSIF z = 2 THEN
   IF Moeilijkheidsgraad = 1 THEN
      RawOutText( 305, 240, 17, "Het eerste, gemakkelijkste niveau  ");
   ELSIF Moeilijkheidsgraad = 2 THEN
      RawOutText( 305, 240, 17, "Het normale niveau                 ");
   ELSIF Moeilijkheidsgraad = 3 THEN
      RawOutText( 305, 240, 17, " Moeilijk!!                        ");
   END;
   IF GeluidAan THEN
      RawOutText( 390, 390, 17, "Geluid Aan");
   ELSE
      RawOutText( 390, 390, 17, "Geluid Uit");
   END;
 ELSIF z = 3 THEN
   RawOutText( 410, 240, 17, "Terug");
   RawOutText( 410, 390, 17, "Quit");

 END;

 END TekstMenu;


 PROCEDURE BeweegPijltjesVertMenu(GrootsteCijfer, Rechthoek_x0, Rechthoek_y0, z: CARDINAL; VAR a: CARDINAL);
 (*LISBETH*)  (*Laat adhv de pijltjes de speler een keuze maken welke optie hij wil*)

 CONST
 extra_yCoord = 150;

 VAR
 x,y: CARDINAL;
 Rechthoek: CARDINAL;


 BEGIN

 a := 1;
    WHILE x <> 13 DO
        IF (KeyPressed()) THEN
           x := VAL(CARDINAL,RdKey());
	   IF x = 0 THEN
	      y := VAL(CARDINAL,RdKey());
	      IF y = 72 THEN
		 IF a >= 2  THEN
		      Rechthoek := DrawBitmapFile(Rechthoek_x0, Rechthoek_y0 + ((a-1)* extra_yCoord), 'Menu/kader_2.bmp',width, height);
		      a := a-1;
		      Rechthoek := DrawBitmapFile(Rechthoek_x0, Rechthoek_y0 + ((a-1)* extra_yCoord), 'Menu/kader_1.bmp',width, height);
		 ELSE
		      Rechthoek := DrawBitmapFile(Rechthoek_x0, Rechthoek_y0 + ((a-1)* extra_yCoord), 'Menu/kader_2.bmp',width, height);
		      a := GrootsteCijfer;
		      Rechthoek := DrawBitmapFile(Rechthoek_x0, Rechthoek_y0 + ((a-1)* extra_yCoord), 'Menu/kader_1.bmp',width, height);
		 END;
		 TekstMenu(z);
	      ELSIF y = 80 THEN
		 IF a < GrootsteCijfer THEN
		      Rechthoek := DrawBitmapFile(Rechthoek_x0, Rechthoek_y0 + ((a-1)* extra_yCoord), 'Menu/kader_2.bmp',width, height);
		      a := a+1;
		      Rechthoek := DrawBitmapFile(Rechthoek_x0, Rechthoek_y0 + ((a-1)* extra_yCoord), 'Menu/kader_1.bmp',width, height);

		 ELSE
		      Rechthoek := DrawBitmapFile(Rechthoek_x0, Rechthoek_y0 + ((a-1)* extra_yCoord), 'Menu/kader_2.bmp',width, height);
		      a := 1;
		      Rechthoek := DrawBitmapFile(Rechthoek_x0, Rechthoek_y0 + ((a-1)* extra_yCoord), 'Menu/kader_1.bmp',width, height);
		 END;
		 TekstMenu(z);
	     ELSIF (y = 77 ) OR (y = 75) THEN
		   IF Soortje = OptiesMenu THEN
		      IF a = 1 THEN
		         MoeilijkheidsGraad(y);
		      ELSIF a = 2 THEN
		         Geluid();
		      END;
		   END;
	      TekstMenu(z);	
              END;
           END;
        END;
     END;

 END BeweegPijltjesVertMenu;


 PROCEDURE TekenKaders(GrootsteCijfer: CARDINAL; Rechthoek_x0, Rechthoek_y0: CARDINAL; Achtergrond: CARDINAL); (*OLIVIA*) (*tekens te kaders bij elk menu met aangegeven cooordinaten*)

 CONST
 extra_yCoord = 150;

 VAR
 menublad: CARDINAL;
 Rechthoek: ARRAY[1..4] OF CARDINAL;
 i : CARDINAL;

 BEGIN

 IF Achtergrond = 1 THEN
    menublad := DrawBitmapFile(0, 0, 'Menu/menu.bmp', width, height);
 ELSE
    menublad := DrawBitmapFile(0, 0, 'Menu/menu_2.bmp', width, height);
 END;


 Rechthoek[1] :=  DrawBitmapFile(Rechthoek_x0, Rechthoek_y0, 'Menu/kader_1.bmp', width, height);

 FOR i := 2 TO GrootsteCijfer DO
    Rechthoek[i] :=  DrawBitmapFile(Rechthoek_x0, Rechthoek_y0 + (i-1)*extra_yCoord, 'Menu/kader_2.bmp', width, height);
 END;

 END TekenKaders;

 PROCEDURE ToonMenu();  (*OLIVIA*)   (*geeft hoofdmenu weer na de intro*)

 CONST

 Rechthoek_x0 = 250;
 Rechthoek_y0 = 100;
 GrootsteCijfer = 4;

 VAR

 a,z: CARDINAL;

 BEGIN

 Soortje := Menu;
 a := 1;
 z := 1;
 ZwartScherm();
 TekenKaders(GrootsteCijfer, Rechthoek_x0, Rechthoek_y0, 1);
 TekstMenu(1);
 BeweegPijltjesVertMenu (GrootsteCijfer, Rechthoek_x0, Rechthoek_y0, z, a);
 LinkToepassing (a);

 END ToonMenu;


 PROCEDURE ToonOptiesSpel();  (*OLIVIA*)      (*zorgt voor het menu dat je krijgt wanneer je op opties drukt tijdens het spel*)

 CONST

 Rechthoek_x0 = 250;
 Rechthoek_y0 = 200;
 extra_xCoord = 0;
 extra_yCoord = 150;
 GrootsteCijfer = 2;
 VAR
 a,z: CARDINAL;

 BEGIN

 Soortje := OptiesSpel;
 ZwartScherm();
 a := 1;
 z:=3;
 TekenKaders(GrootsteCijfer, Rechthoek_x0, Rechthoek_y0, 2);
 TekstMenu(3);
 BeweegPijltjesVertMenu(GrootsteCijfer, Rechthoek_x0, Rechthoek_y0, z, a);

 IF a = 2 THEN
    Einde := FALSE;
    Muis_Dood := MaxAantalLevel +10;
 ELSIF a = 1 THEN
    ZwartScherm();
 END;

 END ToonOptiesSpel;


 PROCEDURE ToonOptiesMenu();  (*OLIVIA*)        (*zorgt voor het menu dat je krijgt wanneer je op opties drukt in het hoofdmenu*)

 CONST

 Rechthoek_x0 = 250;
 Rechthoek_y0 = 200;
 extra_xCoord = 0;
 extra_yCoord = 150;
 GrootsteCijfer = 2;
 VAR
 a,z: CARDINAL;

 BEGIN

 Soortje := OptiesMenu;
 ZwartScherm();
 a := 1;
 z:=2;
 TekenKaders(GrootsteCijfer, Rechthoek_x0, Rechthoek_y0, 2);
 TekstMenu(2);
 BeweegPijltjesVertMenu(GrootsteCijfer, Rechthoek_x0, Rechthoek_y0, z, a);
 ToonMenu();

 END ToonOptiesMenu;

 PROCEDURE ToonIntroBlad();   (*OLIVIA*)      (*geeft allereerste introblad weer met naam van spel op *)

 VAR
 x : CHAR;			
 IntroBitmap : CARDINAL;  	
			
 BEGIN

 PlaySoundEvent(IntroLawaai);
 IntroBitmap := DrawBitmapFile(0, 0, 'Menu/IntroBlad.bmp', width, height);
 x := RdKey();

 END ToonIntroBlad;


 PROCEDURE Instructies();  (*OLIVIA*)   (*geeft bitmap met instructies weer*)

 CONST


 VAR
 ToonTekening: CARDINAL;
 x : CHAR;

 BEGIN

 ZwartScherm();
 ToonTekening := DrawBitmapFile(0,0, 'Menu/Instructies.bmp', width, height);
 x := RdKey();
 ToonMenu();

 END Instructies;

 PROCEDURE MoeilijkheidsGraad(y: CARDINAL);         (*LISBETH*) (*Past de moeilijkheidsgraad aan*)

 BEGIN

 IF y = 75 THEN
    IF Moeilijkheidsgraad > 1 THEN
       Moeilijkheidsgraad := Moeilijkheidsgraad - 1 ;
    END;
 ELSIF y = 77 THEN
    IF Moeilijkheidsgraad < 3 THEN
       Moeilijkheidsgraad := Moeilijkheidsgraad + 1;
    END;
 END;

 END MoeilijkheidsGraad;

 PROCEDURE Pauze();    (**LISBETH**) (** Wanneer er op p gedrukt wordt, zal het spel pauzeren **)

 VAR

 Herbegin : CARDINAL;

 BEGIN

 PauzeBitmap := DrawBitmapFile(0, 0, 'Menu/Pauze.bmp', width, height);

 Herbegin:= VAL(CARDINAL,RdKey());

 WHILE (Herbegin <> 112) AND (Herbegin <> 111) DO
    Herbegin:= VAL(CARDINAL,RdKey());
 END;

 IF Herbegin = 111 THEN
    ToonOptiesSpel();
 END;

 END Pauze;

 PROCEDURE Geluid();   (*OLIVIA*)

 BEGIN

 IF GeluidAan THEN
    GeluidAan := FALSE;
 ELSE
    GeluidAan := TRUE;
 END;

 END Geluid;

(** Highscores **)

 PROCEDURE Sorteren ();       (*LISBETH*)  (*Er wordt geen gebruik gemaakt van een sorteeralgoritme omdat de tabel reeds geordend is.
 						De desbetreffende score wordt op de juiste plaats ingevoegd*)

 VAR

 i,j,k:CARDINAL;

 BEGIN

 i := 0;

 WHILE  Lijst[i].Punten >= Score DO
    i := i+1;
 END;

 FOR j := 9 TO i+1 BY -1 DO
   Lijst[j].Punten := Lijst[j-1].Punten;
   Lijst[j].Naam := Lijst[j-1].Naam;
 END;

 Lijst[i].Punten := Score;

 FOR k := 0 TO 15 DO
    Lijst[i].Naam[k] := Naam[k];
 END;

 END Sorteren;


 PROCEDURE ScoreBewaren();      (*OLIVIA*)     (*Schrijft de nieuwe (bewerkte) array in de file*)

 VAR

 i: CARDINAL;

 BEGIN

 HoogsteScores:= FIO.Create("Scores.txt");

 FOR i:=0 TO 9  DO
    FIO.WrStr(HoogsteScores, Lijst[i].Naam);
    FIO.WrLn(HoogsteScores);
    FIO.WrCard(HoogsteScores, Lijst[i].Punten, 5);
    FIO.WrLn(HoogsteScores);
 END ;

 FIO.Close(HoogsteScores);

 END ScoreBewaren;


 PROCEDURE LaadHighscores(): WinnersArr;           (*OLIVIA*)    (*leest opgeslagen array uit bestand*)

 VAR

 i: CARDINAL ;
 str : ARRAY[0..10] OF CHAR;

 BEGIN

 HoogsteScores:= FIO.OpenRead("Scores.txt");

 FOR i:= 0 TO 9 DO
    FIO.RdStr(HoogsteScores, Lijst[i].Naam);
    Lijst[i].Punten:= FIO.RdCard(HoogsteScores);
    FIO.RdStr(HoogsteScores, str);
 END;
 FIO.Close(HoogsteScores);

 RETURN   Lijst;

END LaadHighscores;


 PROCEDURE ToonHighscores();                   (*OLIVIA*)      (*geeft lijstje met highscores weer*)

 CONST

 y0_coor=150 ;
 x_coor=250 ;
 extra_coor=50;

 VAR

 i: CARDINAL ;
 y_coor: CARDINAL;
 str: ARRAY [0..0] OF CHAR;


 BEGIN

 HoogsteScores := FIO.OpenRead("Scores.txt");
 RawOutText(250,100,17,"De hoogste scores zijn");

 FOR i:= 0 TO 9 DO
    FIO.RdStr(HoogsteScores, Lijst[i].Naam);
    Lijst[i].Punten:= FIO.RdCard(HoogsteScores);
    FIO.RdStr(HoogsteScores, str);
    y_coor:=(y0_coor+ (i * extra_coor));
    RawOutText(x_coor,y_coor,17,Lijst[i].Naam); DrawNumber(x_coor + 200, y_coor+10, Lijst[i].Punten, 17, 0); (*RawOutText(x_coor,y_coor+10,17,ScoreText);*)WrLn;   (*hier zit een fout in, aanvaard geen RawPutText, ook alsik em declareer (al eens geprobeerd)*)
 END;

 FIO.Close(HoogsteScores);

 END ToonHighscores;


 PROCEDURE HighScores();      	(*OLIVIA*)				(*hoofdprogramma van highscores*)

 BEGIN

 Lijst := LaadHighscores();

 IF Score > Lijst[9].Punten THEN
    SchrijfNaam();
    Sorteren();
    ScoreBewaren();
    ZwartScherm();
    ToonHighscores();
 ELSE ToonHighscores();

 END;

 END HighScores;


 PROCEDURE ShowHighScores();       (*Highscores tonen bij het kiezen van deze optie in het menu*)

 VAR
 x: CHAR;

 BEGIN

 ZwartScherm();
 ToonHighscores();
 x := RdKey();
 ToonMenu();

 END ShowHighScores;




 BEGIN            (*** HOOFDPROGRAMMA ***)

   gPseudoRandom := FALSE;
 IF NOT Init(0, 0 , Scr_Width, Scr_Height) THEN  (* de schermgrootte bepalen, coordinaat (1,1) is linksboven  *)
     WrStr("Sorry, graphics doesn't work");WrLn;
 END;

 IF InitSound(TRUE) THEN
 ELSE
    WrStr("Sound doesn't work on this computer..."); WrLn;
 END;

 Moeilijkheidsgraad := 2;
 GeluidAan := TRUE;
 ToonIntroBlad();
 StartSpel();

 END   KillThemAll3.